#pragma once

#include "Database.h"

namespace hyplex::drakan
{
	struct Object: INode
	{
		using Colour = std::array<uint8_t, 4>;
		struct ObjectRef
		{
			unsigned int id = 0;
		};
		using ObjectRefList = std::vector<ObjectRef>;
		using Value = std::variant<std::monostate, int, float, String, ObjectRef, Colour, ObjectRefList, std::vector<int>, std::vector<float>>;

		struct Property
		{
			String name;
			EDataType type{};
			int16_t index = 0;
			Value value;

			String toString() const;
		};

		unsigned int id = 0;
		String name;
		unsigned int modelId = 0;
		unsigned int classId = 0;
		std::vector<Property> props;

		static std::vector<Property> readProperties(BasicBufferedLexState& bin, bool hasIndices = false);

		void consumeData(const Entry& entry, BasicBufferedLexState& bin);
		virtual ENodeType getType() const noexcept override;
		virtual void dumpNode(const NodeDumpArg& arg) const override;
	};

}